/*
 * cntable.h : caf neighbor list
 */

#ifndef caf_ntable_h_
#define caf_ntable_h_


#include "config.h" 


/* entry to the caf neighbor table */

class cntable_ent {
public:
  cntable_ent() { bzero(this, sizeof(cntable_ent));}
  cntable_ent  *next;   // pointer to the next
  u_int32_t     nid;    // node id
  int32_t       cid;      // cluster id
  u_int32_t     state;  // node state
  u_int32_t     enlt;   // estimated node live time
  u_int32_t     stime;  // high mobility adaption
  u_int32_t     nlen;   // how many cluster leader node I can hear
  u_int32_t     nlist[20]; // pointer to an array of cluster leaders
};


/* caf neighbor table */

class CAFnTable {

  public:
    CAFnTable();
    void AddEntry(const cntable_ent &ent);
    void cleanTable();
    cntable_ent *FirstEntry();
    cntable_ent *NextEntry();
    cntable_ent  *GetEntry(u_int32_t nodeid);
    u_int32_t   tablesize();

  private:
    cntable_ent *list_start;   // head of the routing entry
    cntable_ent *crtp;         // current queue pointer
    u_int32_t   tablen;        // how many neighbors

};

#endif














