
#include <stdlib.h>
 
#include "random.h"
#include "trafgen.h"
#include "ranvar.h"
#include "object.h"
#include "trafgen.h"

class TrafficTraceConvert : public TclObject {

private:
    char *name_;	// tracefile name
    FILE *fp;
    int time_;
    int size_;
public:

    TrafficTraceConvert();

    struct tracerec {
        u_int32_t trec_time; /* inter-packet time (usec) */
        u_int32_t trec_size; /* size of packet (bytes */
    } t;    



    void record();
    void finish();
    int TrafficTraceConvert::command(int argc, const char*const* argv);
};

static class TrafficTraceConvertClass : public TclClass {
 public:
	TrafficTraceConvertClass() : TclClass("TrafficTraceConvert") {}
	TclObject* create(int, const char*const*) {
		return (new TrafficTraceConvert());
	}
} class_traffic_trace_convert;

TrafficTraceConvert::TrafficTraceConvert() : size_(0), time_(0)
{
	bind("time_", &time_);
	bind("size_", &size_);
	
}

void TrafficTraceConvert::record()
{
    t.trec_time = ntohl(time_);
    t.trec_size = ntohl(size_);


    if (fwrite((char *)&t, sizeof(tracerec), 1, fp) != 1) {
        printf("write failed\n");
	exit;
    }
 
}         

void TrafficTraceConvert::finish()
{

	fclose(fp);
}             

int TrafficTraceConvert::command(int argc, const char*const* argv)
{
	if (argc == 2) {

	    if (strcmp(argv[1], "record") == 0) {
                record();
                return TCL_OK;
            } 
	    if (strcmp(argv[1], "finish") == 0) { 
		finish();
		return TCL_OK;
	    }
	}
 
        if (argc == 3) {
                if (strcmp(argv[1], "filename") == 0) {

                        name_ = new char[strlen(argv[2])+1];
                        strcpy(name_, argv[2]);
			if ((fp = fopen(name_, "w")) == NULL) {
			  printf("can't open file %s for write\n", name_);
			  return(TCL_ERROR);
			} 
                        return(TCL_OK);
                }
        }
	return TclObject::command(argc, argv);
}                          















